﻿Imports System.Runtime.InteropServices
Public Class Form1
    <DllImport("user32")>
    Private Shared Function HideCaret(ByVal hWnd As IntPtr) As Boolean
    End Function
    Private textBoxForDisplay As TextBox
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        C1FlexGrid1.Rows.DefaultSize = 40
        For intRow As Integer = C1FlexGrid1.Rows.Fixed To C1FlexGrid1.Rows.Count - 1

            For intCol As Integer = C1FlexGrid1.Cols.Fixed To C1FlexGrid1.Cols.Count - 1
                Dim text As String = $"row {intRow}, col {intCol}"

                If intCol = 2 Then
                    text = "[0] " & text & Environment.NewLine & "[1] " & text + Environment.NewLine & "[2] " & text + Environment.NewLine & "[3] " & text + Environment.NewLine & "[4] " & text + Environment.NewLine & "[5] " & text
                End If

                C1FlexGrid1(intRow, intCol) = text
            Next
        Next
        textBoxForDisplay = New TextBox()
        textBoxForDisplay.ScrollBars = ScrollBars.Both
        textBoxForDisplay.Multiline = True
        textBoxForDisplay.ReadOnly = True
        C1FlexGrid1.Controls.Add(textBoxForDisplay)
        textBoxForDisplay.Visible = False
        AddHandler textBoxForDisplay.GotFocus, AddressOf Tbx_GotFocus

    End Sub

    Private Sub Tbx_GotFocus(ByVal sender As Object, ByVal e As EventArgs)
        Dim textBox1 As TextBox = TryCast(sender, TextBox)
        If textBox1.[ReadOnly] = True Then
            HideCaret(textBox1.Handle)
        End If
    End Sub
    Private Sub C1FlexGrid1_AfterSelChange(sender As Object, e As C1.Win.C1FlexGrid.RangeEventArgs) Handles C1FlexGrid1.AfterSelChange
        If e.NewRange.LeftCol = 2 Then
            textBoxForDisplay.Visible = True
            Dim rectCell As Rectangle = C1FlexGrid1.GetCellRect(e.NewRange.TopRow, e.NewRange.LeftCol)
            textBoxForDisplay.Location = rectCell.Location
            textBoxForDisplay.Size = rectCell.Size
            textBoxForDisplay.Text = CStr(C1FlexGrid1(e.NewRange.TopRow, e.NewRange.LeftCol))
        Else
            textBoxForDisplay.Visible = False
        End If
    End Sub
End Class
